//
//  SplashViewController.m
//  stylepop
//
//  Created by 경영 임 on 13. 1. 22..
//  Copyright (c) 2013년 Pinatalabs. All rights reserved.
//

#import "AppDelegate.h"
#import "SplashViewController.h"

@interface SplashViewController ()

@end

@implementation SplashViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        

        self.view.frame =  [UIScreen mainScreen].applicationFrame;
        UIImageView *logoView;        
        int corPosY = 0;

        if( [UIScreen mainScreen].bounds.size.height == 568.0 )
        {
            corPosY = 88;
            logoView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"Default-568h.png"]];
        }
        else
        {
            logoView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"Default.png"]];
        }

        CGRect rectLogo = logoView.frame; rectLogo.origin.y -= 20;
        [logoView setFrame:rectLogo];
        [self.view addSubview:logoView];
        
        _loadingView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"img_loading_01.png"]];
        _loadingView.center = CGPointMove(self.view.center,0,65);
        _loadingView.animationImages = [NSArray arrayWithObjects:[UIImage imageNamed:@"img_loading_01.png"],[UIImage imageNamed:@"img_loading_02.png"],[UIImage imageNamed:@"img_loading_03.png"],[UIImage imageNamed:@"img_loading_04.png"],[UIImage imageNamed:@"img_loading_05.png"],[UIImage imageNamed:@"img_loading_06.png"],[UIImage imageNamed:@"img_loading_07.png"], nil];
        _loadingView.animationDuration = 0.7f;
        _loadingView.animationRepeatCount = 0;
        [_loadingView startAnimating];
        [self.view addSubview:_loadingView];
        
        _viewForLogin = [[UIView alloc] initWithFrame:[UIScreen mainScreen].applicationFrame];
        UIButton *btnFBSign = [[UIButton alloc] initWithFrame:CGRectMake((320-278)/2.0f,325+corPosY,278,45)];
        [btnFBSign setImage:[UIImage imageNamed:@"btn_fb_login_n"] forState:UIControlStateNormal];
        [btnFBSign setImage:[UIImage imageNamed:@"btn_fb_login_h"] forState:UIControlStateHighlighted];
        [_viewForLogin addSubview:btnFBSign];
        
        UILabel *labelSignIn = [[UILabel alloc] initWithFrame:CGRectMake(15, 415+corPosY, 150,10)];
        [labelSignIn setText:@"STYLEPOP 아이디로"];
        labelSignIn.font = [UIFont fontWithName:@"HelveticaNeue-Bold" size:8];
        [labelSignIn setTextColor:[UIColor colorWithRed:0.5 green:0.5 blue:0.5 alpha:0.5]];
        [labelSignIn setBackgroundColor:[UIColor clearColor]];
        [_viewForLogin addSubview:labelSignIn];
        
        UILabel *labelSignUp = [[UILabel alloc] initWithFrame:CGRectMake(178, 415+corPosY, 150,10)];
        [labelSignUp setText:@"STYLEPOP 아이디 만들기"];
        [labelSignUp setBackgroundColor:[UIColor clearColor]];
        [labelSignUp setTextColor:[UIColor colorWithRed:0.5 green:0.5 blue:0.5 alpha:0.5]];
        labelSignUp.font = [UIFont fontWithName:@"HelveticaNeue-Bold" size:8];
        [_viewForLogin addSubview:labelSignUp];
        
        UIButton *btnSignIn = [[UIButton alloc] initWithFrame:CGRectMake(5, 375+corPosY, 150, 60)];
        [btnSignIn.titleLabel setShadowColor:[UIColor redColor]];
        btnSignIn.titleLabel.font = [UIFont fontWithName:@"HelveticaNeue-Bold" size:14];
        [btnSignIn.titleLabel setShadowColor:[UIColor blackColor]];
        [btnSignIn.titleLabel setShadowOffset:CGSizeMake(3, 3)];
        [btnSignIn setTitleColor:[UIColor grayColor] forState:UIControlStateHighlighted];
        [btnSignIn setTitle:@"Login in with E-mail" forState:UIControlStateNormal];
        [_viewForLogin addSubview:btnSignIn];
        
        UIButton *btnSignUp = [[UIButton alloc] initWithFrame:CGRectMake(165, 375+corPosY, 150, 60) ];
        btnSignUp.titleLabel.font = [UIFont fontWithName:@"HelveticaNeue-Bold" size:14];
        [btnSignUp setTitleColor:[UIColor grayColor] forState:UIControlStateHighlighted];
        [btnSignUp.titleLabel setShadowColor:[UIColor blackColor]];
        [btnSignUp.titleLabel setShadowOffset:CGSizeMake(3, 3)];
        [btnSignUp setTitle:@"Sign up with Email" forState:UIControlStateNormal];
        [_viewForLogin addSubview:btnSignUp];
        
        [btnFBSign addTarget:self action:@selector(actionBtnFBLogin:) forControlEvents:UIControlEventTouchUpInside];
        [btnSignIn addTarget:self action:@selector(actionBtnSignIn:) forControlEvents:UIControlEventTouchUpInside];
        [btnSignUp addTarget:self action:@selector(actionBtnSignUp:) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:_viewForLogin];
        
        _viewForSignin = [[SignInView alloc] initWithFrame:CGRectMake(320, 70, 280, 160)];
        [self.view addSubview:_viewForSignin];
        
        _viewForSignup = [[SignUpView alloc] initWithFrame:CGRectMake(320, 50, 280, 340)];
        [self.view addSubview:_viewForSignup];
        
        [_viewForLogin setHidden:YES];
        [_viewForSignin setHidden:YES];
        [_viewForSignup setHidden:YES];
    }
    return self;
}

-(void) dealloc
{
    [super dealloc];
    [_loadingView dealloc];
    [_viewForLogin dealloc];
    [_viewForSignin dealloc];
    [_viewForSignup dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

-(void)viewWillAppear:(BOOL)animated
{
    [[UIApplication sharedApplication] setStatusBarHidden:NO];
    
    SignManager *signManager = [SignManager sharedInstance];
    [[SignManager sharedInstance] loadLoginInfo];

    AppDelegate *appDelegate = (AppDelegate *)[UIApplication sharedApplication].delegate;
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(actionEntrance:)
                                                 name:FBSessionStateChangedNotification object:nil];
    int64_t delayInSeconds = 0.2;
    dispatch_time_t popTime = dispatch_time(DISPATCH_TIME_NOW, delayInSeconds * NSEC_PER_SEC);
    dispatch_after(popTime, dispatch_get_main_queue(), ^(void){
        if(signManager.auth_token)
        {
            if(signManager.isFBLogin) //fb으로 접속 했던 사람
            {
                [appDelegate openSessionWithAllowLoginUI:YES];
                //자동으로 actionEntrance호출 
            }
            else // sign in으로 접속했던 사람
            {
                [appDelegate openSessionWithAllowLoginUI:NO];
                //접속 성공으로
                [SignManager SignInSuccess];
            }
        }
        else // 신규 고객
        {
            [_loadingView setHidden:YES];
            [_viewForLogin setHidden:NO];
            // 로그인 가능 버튼 표시
        }
    });
}

- (void)actionEntrance:(NSNotification *)note
{
    NSLog(@"ActionEntrance");
    FBSession *session =(FBSession *) note.object;
    if(session.state == FBSessionStateOpen || session.state ==FBSessionStateOpenTokenExtended )
    {
        [SignManager send_MFB_SIGNIN:^(BOOL isSuccess){}];
    }
    else
    {
        //실패인경우 다시 
        [_loadingView setHidden:YES];
        [_viewForLogin setHidden:NO];
    }
}

-(void)viewDidDisappear:(BOOL)animated
{
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                          name:FBSessionStateChangedNotification object:nil];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


-(void) actionBtnSignUp:(id)sender
{
    [_viewForSignup setHidden:NO];
    [UIView transitionWithView:_viewForSignup duration:0.3 options:UIViewAnimationOptionCurveEaseIn animations:^{
        CGRect a = _viewForSignup.frame;
        a.origin.x =20;
        [_viewForSignup setFrame:a];
        _viewForSignup.alpha = 1;
    } completion:^(BOOL finished) {
        _viewForSignup.alpha = 1;
    }];
    [UIView transitionWithView:_viewForLogin duration:0.3 options:UIViewAnimationOptionTransitionCrossDissolve animations:^{
        _viewForLogin.alpha = 0;
    } completion:^(BOOL finished) {
        _viewForLogin.alpha = 0;
    }];
}

-(void) actionBtnSignIn:(id)sender
{
    [_viewForSignin setHidden:NO];
    [UIView transitionWithView:_viewForSignin duration:0.3 options:UIViewAnimationOptionCurveEaseIn animations:^{
        CGRect a = _viewForSignin.frame;
        a.origin.x =20;
        [_viewForSignin setFrame:a];
        _viewForSignin.alpha = 1;
    } completion:^(BOOL finished) {
        _viewForSignin.alpha = 1;
    }];
    [UIView transitionWithView:_viewForLogin duration:0.3 options:UIViewAnimationOptionTransitionCrossDissolve animations:^{
        _viewForLogin.alpha = 0;
    } completion:^(BOOL finished) {
        _viewForLogin.alpha = 0;
    }];
}


-(void) onDimissSignUpPopup:(id)sender
{
    [_viewForSignup endEditing:YES];    
    [UIView transitionWithView:_viewForSignup duration:0.3 options:
     UIViewAnimationOptionCurveEaseIn
                    animations:^{
                        CGRect a = _viewForSignup.frame;
                        a.origin.x =320;
                        [_viewForSignup setFrame:a];
                        _viewForSignup.alpha = 0;
                    } completion:^(BOOL finished) {
                        _viewForSignup.alpha = 0;
                    }];
    [UIView transitionWithView:_viewForLogin duration:0.3 options:UIViewAnimationOptionTransitionCrossDissolve animations:^{
        _viewForLogin.alpha = 1;
    } completion:^(BOOL finished) {
        _viewForLogin.alpha = 1;
    }];
}

-(void) onDimissSignInPopup:(id)sender
{
    [_viewForSignin endEditing:YES];
    [UIView transitionWithView:_viewForSignin duration:0.3 options:
     UIViewAnimationOptionCurveEaseIn
                    animations:^{
        CGRect a = _viewForSignin.frame;
        a.origin.x =320;
        [_viewForSignin setFrame:a];
        _viewForSignin.alpha = 0;
    } completion:^(BOOL finished) {
        _viewForSignin.alpha = 0;
    }];
    [UIView transitionWithView:_viewForLogin duration:0.3 options:UIViewAnimationOptionTransitionCrossDissolve animations:^{
        _viewForLogin.alpha = 1;
    } completion:^(BOOL finished) {
        _viewForLogin.alpha = 1;
    }];
}

-(void)actionBtnFBLogin:(id)sender
{
    AppDelegate *appdelegate = (AppDelegate *)[UIApplication sharedApplication].delegate;
    [[NSNotificationCenter defaultCenter] addObserver:self
                                          selector:@selector(actionEntrance:)
                                          name:FBSessionStateChangedNotification object:nil];
    [appdelegate openSessionWithAllowLoginUI:YES];
}
@end
