//
//  CountDownView.m
//  stylepop
//
//  Created by 경영 임 on 13. 1. 28..
//  Copyright (c) 2013년 Pinatalabs. All rights reserved.
//

#import "CountDownView.h"

@implementation CountDownView

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setBounds:CGRectMake(0,0,128,25)];
        [self setClipsToBounds:YES];
        // Initialization code

        bStartTimer = NO;

        _viewCountNum  = [[NSMutableArray alloc] init];
        _labelCountNum  = [[NSMutableArray alloc] init];
        _labelCountNum2 = [[NSMutableArray alloc] init];
        
        UIImageView * a = [[UIImageView alloc] initWithFrame:CGRectMake(0,0,128,25)];
        [a setImage:[UIImage imageNamed:@"fram_time"]];
        [self addSubview:a];
        int pX = 3;
        for(int i=0;i<6;i++)
        {
            if( i== 2) pX+=6;
            if( i== 4) pX+=6;
            UILabel* b = [[UILabel alloc] initWithFrame:CGRectMake(i*20+pX, 3, 13, 18)];
            [b setText:[NSString stringWithFormat:@"%d",i]];
            b.font = [UIFont fontWithName:@"HelveticaNeue-Bold" size:20];
            [b setBackgroundColor:[UIColor blackColor]];
            [b setTextColor:[UIColor whiteColor]];
            [_labelCountNum addObject:b];
            
            UILabel* c = [[UILabel alloc] initWithFrame:CGRectMake(i*20+pX, 3, 13, 18)];
            [c setText:[NSString stringWithFormat:@"%d",i]];
            c.font = [UIFont fontWithName:@"HelveticaNeue-Bold" size:20];
            [c setBackgroundColor:[UIColor clearColor]];
            [c setTextColor:[UIColor whiteColor]];
            [_labelCountNum2 addObject:c];

            [self addSubview:c];
//            [self addSubview:a];
            [self addSubview:b];
        }
        
    }
    return self;
}

-(void) dealloc
{
    [_startTime dealloc];
    [_endTime dealloc];
    [_viewCountNum dealloc];
    [_labelCountNum dealloc];
    [_labelCountNum2 dealloc];
    [super dealloc];
}

-(void) startCount:(NSString*)start end:(NSString*)end
{

    NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
    [dateFormat setDateFormat:@"yyyy-MM-ddhh:mm:ssZ"];
    NSString *str = [[start substringToIndex:10] stringByAppendingString:[start substringFromIndex:11]];
    NSString *estr = [[end substringToIndex:10] stringByAppendingString:[end substringFromIndex:11]];
    _startTime = [[dateFormat dateFromString:str] retain];
    _endTime = [[dateFormat dateFromString:estr] retain];
    [dateFormat release];

    if( !bStartTimer )
    {
        bStartTimer = YES;
        [NSTimer scheduledTimerWithTimeInterval:0.2f target:self selector:@selector(onTime) userInfo:nil repeats:YES];
    }
}

-(void) changeCountNum:(int)index to:(int)num
{
    if( index<0 || index>6 ) return;
    UILabel *label =[_labelCountNum objectAtIndex:index];

    if( [label.text intValue] != num )
    {
        //[label setText:[NSString stringWithFormat:@"%d",num]];
        [[_labelCountNum2 objectAtIndex:index] setText:[NSString stringWithFormat:@"%d",num]];
        label.alpha = 1.0f;
        [UIView transitionWithView:label duration:0.4f options:
         UIViewAnimationCurveLinear
                        animations:^{
                            CGRect c = label.frame;
                            c.origin.y = 30.0f;
                            [label setFrame:c];
                            label.alpha = 1.0f;
                        } completion:^(BOOL finished) {
                            CGRect c = label.frame;
                            c.origin.y = 3.0f;
                            [label setFrame:c];
                            label.alpha = 1.0f;
                            [label setText:[NSString stringWithFormat:@"%d",num]];
                        }];
    }
}

-(void) onTime
{
    double aa = [_startTime timeIntervalSinceNow];
    if( aa<0 ) {
        aa = [_endTime timeIntervalSinceNow];
    }
    if( aa<0 ) {
        // stop and disable countdown
        return;
    }
    if( timePrevious== aa) return;
    timePrevious = aa;    
    [self changeCountNum:5 to:(int)(aa)%60%10];
    [self changeCountNum:4 to:(int)(aa)%60/10];
    [self changeCountNum:3 to:(int)(aa/60)%24%10];
    [self changeCountNum:2 to:(int)(aa/60)%24/10];
    [self changeCountNum:1 to:(int)(aa/(60*60))%10];
    [self changeCountNum:0 to:(int)(aa/(60*60))/10];
    timePrevious = aa;
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

@end
