//
//  EventItemViewController.m
//  stylepop
//
//  Created by 경영 임 on 13. 1. 23..
//  Copyright (c) 2013년 Pinatalabs. All rights reserved.
//

#import "EventItemViewController.h"
#import "CountDownView.h"

@interface EventItemViewController ()

@end

@implementation EventItemViewController

- (id)initWithFrame:(CGRect)frame dic:(NSDictionary*)dic
{
    self = [super init];
    if (self) {
        self.view.frame = frame;
        
        _eventImage = [[AsyncImageView alloc] initWithFrame:CGRectMake(0,0,self.view.bounds.size.width,self.view.bounds.size.height)];
        [_eventImage setContentMode:UIViewContentModeScaleAspectFit];

        // Custom initialization
        _eventDic = dic;
        NSString* imgUrl = [[dic objectForKey:@"mobile_image"] objectForKey:@"url"];
        [_eventImage setImageURL:[NSURL URLWithString:[NSString stringWithFormat:@"%@%@",_address,imgUrl]]];
        [self.view addSubview:_eventImage];
        
        UILabel* labelName = [[UILabel alloc] initWithFrame:CGRectMake(10,frame.size.height-100,220,40)];
        [labelName setText:[dic objectForKey:@"name"]];

        [labelName setBackgroundColor:[UIColor colorWithWhite:0.0 alpha:0.8]];
        labelName.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:20];
        labelName.shadowOffset = CGSizeMake(2, 2);
        labelName.shadowColor = [UIColor blackColor];
        labelName.textColor = [UIColor whiteColor];
        [labelName sizeToFit];
        
        UILabel* labelTime = [[UILabel alloc] initWithFrame:CGRectMake(10,frame.size.height-70,220,40)];
        [labelTime setText:
         [NSString stringWithFormat:@"%@~%@",
          [[dic objectForKey:@"start_time"] substringToIndex:10],
          [[dic objectForKey:@"start_time"] substringToIndex:10]]
          ];
        [labelTime setBackgroundColor:[UIColor colorWithWhite:0.0 alpha:0.8]];
        labelTime.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:20];
        labelTime.textColor = [UIColor whiteColor];
        labelTime.shadowColor = [UIColor blackColor];
        labelTime.shadowOffset = CGSizeMake(2, 2);
        [labelTime sizeToFit];
        
        [self.view setUserInteractionEnabled:NO];

        [self.view addSubview:labelName];
        [self.view addSubview:labelTime];

        _blackView = [[UIView alloc] initWithFrame:CGRectMake(0,0,self.view.bounds.size.width,self.view.bounds.size.height)];

        _countdownView = [[CountDownView alloc] initWithFrame:CGRectMake(0, 0, 320, 60)];
        [self.view addSubview: _countdownView];
        
        [_blackView setBackgroundColor:[UIColor blackColor]];
        _blackView.alpha = 1.0f;
        [self.view addSubview:_blackView];

        [_eventImage setUserInteractionEnabled:NO];

        
        [_countdownView startCount:[dic objectForKey:@"start_time"] end:[dic objectForKey:@"end_time"]];

    }
    return self;
}

-(void) dealloc
{
    [_countdownView dealloc];
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *t = [touches anyObject];
    touchPos = [t locationInView:self.view];
    viewRect = self.view.frame;
    viewRect = self.parentViewController.view.frame;
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *touch = [touches anyObject];
    CGPoint location = [touch locationInView:self.view];
    CGPoint prevLocation = [touch previousLocationInView:self.view];
    viewRect.origin.y += (location.y-prevLocation.y);
    [self.view.superview setFrame:viewRect];
//    [self.view setFrame:viewRect];
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    
}

- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event
{
    
}


@end
