//
//  EventListViewController.m
//  stylepop
//
//  Created by 경영 임 on 13. 1. 22..
//  Copyright (c) 2013년 Pinatalabs. All rights reserved.
//

#import "EventListViewController.h"
#import "EventItemViewController.h"
#import "SVHTTPRequest.h"

@interface EventListViewController ()

@end

@implementation EventListViewController


-(id) initWithFrame:(CGRect) frame
{
    self = [super init];
    if( self )
    {
        [self.view setFrame:frame];
    }
    return self;
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
//        UIButton *btn = [[UIButton alloc] initWithFrame:CGRectMake(160, 200, 200, 30)];
//        [btn setTitle:@"Signout" forState:UIControlStateNormal];
//        [btn addTarget:self action:@selector(onSignOut:) forControlEvents:UIControlEventTouchUpInside];
//        [self.view addSubview:btn];
        [self.view setUserInteractionEnabled:YES];
        currentPage = 0;
    }
    return self;
}

-(void) dealloc
{
    [_arrayEventItems removeAllObjects];
    _arrayEventItems = nil;
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    _arrayEventItems = [[NSMutableArray alloc] initWithObjects:nil];
	// Do any additional setup after loading the view.
}

-(void) reloadEventList
{
    for(int i=0;i<[_arrayEventItems count];i++)
    {
        EventItemViewController *vc =[_arrayEventItems objectAtIndex:i];
        [vc.view removeFromSuperview];
        [vc removeFromParentViewController];
        [vc release];
    }
    [_arrayEventItems removeAllObjects];
    
    currentPage = 0;

    
//    for(int i=[[[DataManager sharedInstance] arrayEventDic] count]-1;i>=0;i--)
    for(int i=0;i<[[[DataManager sharedInstance] arrayEventDic] count];i++)
    {
        NSDictionary *dic = [[[DataManager sharedInstance] arrayEventDic] objectAtIndex:i];
        NSLog(@"%@",[dic objectForKey:@"name"]);
        CGRect a = CGRectMake(5, 0*self.view.frame.size.height, self.view.frame.size.width, self.view.frame.size.height);
        EventItemViewController* itemVC = [[EventItemViewController alloc] initWithFrame:a dic:dic];
        [self.view addSubview:itemVC.view];
        [self addChildViewController:itemVC];
        [_arrayEventItems addObject:itemVC];
        itemVC.view.alpha = 0.0;
        itemVC.blackView.alpha = 0.0f;
    }
    
    if( [_arrayEventItems count]>0)
    {
        EventItemViewController*vc = [_arrayEventItems objectAtIndex:0];
        vc.blackView.alpha = 0.0f;
        vc.view.alpha = 1.0f;
    }
}

-(void) onSignOut:(id)sender
{
    [SignManager send_SignOut:^(BOOL isSuccess){}];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *t = [touches anyObject];
    touchPos = [t locationInView:self.view];
    EventItemViewController* cPage = [_arrayEventItems objectAtIndex:currentPage];
    viewRect = cPage.view.frame;
    previousTime = [t timestamp];
}

-(void) cancelItemMove
{
    EventItemViewController* cPage = [_arrayEventItems objectAtIndex:currentPage];    
    viewRect.origin.y = 0;
    [cPage.view setFrame:viewRect];
    cPage.blackView.alpha = 0.2f;
    [UIView transitionWithView:cPage.blackView duration:0.2f options:
              UIViewAnimationOptionCurveEaseIn
                             animations:^{
                                 cPage.blackView.alpha = 0.0f;
                             } completion:^(BOOL finished) {
                                 cPage.view.alpha = 1.0f;
                             }];
}

- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *touch = [touches anyObject];
    CGPoint location = [touch locationInView:self.view];
    CGPoint prevLocation = [touch previousLocationInView:self.view];
    
    // get speed
    const float lambda = 0.8f; // the closer to 1 the higher weight to the next touch
    newSpeed = (1.0 - lambda) * oldSpeed + lambda* ((location.y-prevLocation.y)/([touch timestamp]-previousTime));
    oldSpeed = newSpeed;
    previousTime = [touch timestamp];
    viewRect.origin.y += (location.y-prevLocation.y);

    EventItemViewController* nPage = nil;
    EventItemViewController* cPage = [_arrayEventItems objectAtIndex:currentPage];
    if( viewRect.origin.y<0 )
    {
        if (currentPage<[_arrayEventItems count]-1) {
            nPage = [_arrayEventItems objectAtIndex:currentPage+1];
            CGRect a = cPage.view.frame;
            a.origin.y = 0;
            [cPage.view setFrame:a];
            a = viewRect; a.origin.y +=self.view.frame.size.height;
            [nPage.view setFrame:a];
            float ap = (viewRect.origin.y+ self.view.frame.size.height)/self.view.frame.size.height;
            cPage.blackView.alpha = 1.0f-ap;
            nPage.blackView.alpha = 0.0f;
            nPage.view.alpha = 1.0f;
            [self.view bringSubviewToFront:cPage.view];
            [self.view bringSubviewToFront:nPage.view];
        }
        else
        {
            [self cancelItemMove];
            return;
        }
    }
    else
    {
        if (currentPage>0)
        {
            nPage = [_arrayEventItems objectAtIndex:currentPage-1];
            CGRect a = nPage.view.frame;
            a.origin.y = 0;
            [nPage.view setFrame:a];
            [cPage.view setFrame:viewRect];            
            float ap = (self.view.frame.size.height-viewRect.origin.y)/self.view.frame.size.height;
            nPage.blackView.alpha = 0.0;
            cPage.blackView.alpha = 1.0f-ap;
            nPage.view.alpha = 1.0f;
            [self.view bringSubviewToFront:nPage.view];            
            [self.view bringSubviewToFront:cPage.view];
        }
        else
        {
            [self cancelItemMove];
            return;
        }
    }
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *touch = [touches anyObject];
    CGPoint location = [touch locationInView:self.view];
    CGPoint prevLocation = [touch previousLocationInView:self.view];
    // get speed    
    const float lambda = 0.8f; // the closer to 1 the higher weight to the next touch
    newSpeed = (1.0 - lambda) * oldSpeed + lambda* ((location.y-prevLocation.y)/([touch timestamp]-previousTime));
    oldSpeed = newSpeed;
    previousTime = [touch timestamp];
    viewRect.origin.y += (location.y-prevLocation.y);
    viewRect.origin.y += ([touch timestamp]-previousTime)*oldSpeed*10;
    
    EventItemViewController* cPage = [_arrayEventItems objectAtIndex:currentPage];
    if( viewRect.origin.y<-1*self.view.frame.size.height/4.0f)
    {
        if( currentPage<[_arrayEventItems count]-1 )
        {
            currentPage = currentPage+1;
            EventItemViewController* pPage = [_arrayEventItems objectAtIndex:currentPage];
            [UIView transitionWithView:pPage.view duration:0.2f options:
             UIViewAnimationOptionCurveEaseIn
                animations:^{
                    CGRect a = pPage.view.frame;
                    a.origin.y = 0;
                    [cPage.view setFrame:a];
                    [pPage.view setFrame:a];
                    pPage.blackView.alpha = 0.0f;
                    cPage.blackView.alpha = 1.0f;
                } completion:^(BOOL finished) {
                    cPage.view.alpha = 0.0f;
                }];
            return;            
        }
    } else if( viewRect.origin.y>self.view.frame.size.height/4.0f)
    {
        if( currentPage>0 )
        {
            currentPage = currentPage-1;
            EventItemViewController* pPage = [_arrayEventItems objectAtIndex:currentPage];
            [UIView transitionWithView:pPage.view duration:0.2f options:UIViewAnimationOptionCurveEaseIn
                animations:^{
                        CGRect a = pPage.view.frame;
                        a.origin.y = 0;
                        [pPage.view setFrame:a];
                        a.origin.y = self.view.frame.size.height;
                        [cPage.view setFrame:a];
                        pPage.blackView.alpha = 0.0f;
                        cPage.blackView.alpha = 1.0f;
                    } completion:^(BOOL finished) {
                        cPage.view.alpha = 0.0f;
                    }];
            return;
        }
    }
    
    
    if( viewRect.origin.y<0)
    {
        if( currentPage<[_arrayEventItems count]-1 )
        {
            currentPage = currentPage+1;
            EventItemViewController* pPage = [_arrayEventItems objectAtIndex:currentPage];
            
            [UIView transitionWithView:cPage.view duration:0.2f options:UIViewAnimationOptionCurveEaseIn
                            animations:^{
                                CGRect a = pPage.view.frame;
                                a.origin.y = self.view.frame.size.height;
                                [pPage.view setFrame:a];
                                pPage.blackView.alpha = 1.0f;
                                cPage.blackView.alpha = 0.0f;
                            } completion:^(BOOL finished) {
                                cPage.view.alpha = 1.0f;
                            }];
        }
    }
    else
    {
        [UIView transitionWithView:cPage.view duration:0.2f options:UIViewAnimationOptionCurveEaseIn
                        animations:^{
                            CGRect a = cPage.view.frame;
                            a.origin.y = 0;
                            [cPage.view setFrame:a];
                            cPage.blackView.alpha = 0.0f;
                        } completion:^(BOOL finished) {
                            cPage.view.alpha = 1.0f;
                        }];
    }
}

- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event
{
    
}

@end
