//
//  MainViewController.m
//  stylepop
//
//  Created by 경영 임 on 13. 1. 24..
//  Copyright (c) 2013년 Pinatalabs. All rights reserved.
//

#import "MainViewController.h"

@interface MainViewController ()

@end

@implementation MainViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        [self.view setFrame:[[UIScreen mainScreen] bounds]];
        [self.view setBackgroundColor:[UIColor blackColor]];
        
        // Custom initialization
        CGRect frame = [[UIScreen mainScreen] bounds];
        frame.origin.y = 60; frame.size.height -= 80;

#ifdef __TEST_BACK_MENU
        _tableEventList = [[UITableView alloc] initWithFrame:frame];
        _tableEventList.dataSource = self;
        _tableEventList.delegate = self;
        _tableEventList.separatorStyle = UITableViewCellSeparatorStyleNone;
        [_tableEventList setBackgroundColor:[UIColor blackColor]];
        _tableEventList.showsVerticalScrollIndicator = NO;
        [self.view addSubview:_tableEventList];
        
        _arrayColor = [[NSArray alloc] initWithObjects:
                       [UIColor colorWithRed:235/255.f green:65/255.f blue:60/255.f alpha:1.0],
                       [UIColor colorWithRed:120/255.f green:65/255.f blue:100/255.f alpha:1.0],
                       [UIColor colorWithRed:50/255.f green:100/255.f blue:140/255.f alpha:1.0],
                       [UIColor colorWithRed:80/255.f green:160/255.f blue:180/255.f alpha:1.0],
                       [UIColor colorWithRed:100/255.f green:180/255.f blue:120/255.f alpha:1.0],
                       [UIColor colorWithRed:100/255.f green:220/255.f blue:150/255.f alpha:1.0],
                       [UIColor colorWithRed:85/255.f green:90/255.f blue:110/255.f alpha:1.0],
                       [UIColor colorWithRed:28/255.f green:28/255.f blue:28/255.f alpha:1.0],
                       [UIColor colorWithRed:235/255.f green:65/255.f blue:60/255.f alpha:1.0],
                       [UIColor colorWithRed:120/255.f green:65/255.f blue:100/255.f alpha:1.0],
                       [UIColor colorWithRed:50/255.f green:100/255.f blue:140/255.f alpha:1.0],
                       [UIColor colorWithRed:80/255.f green:160/255.f blue:180/255.f alpha:1.0],
                       [UIColor colorWithRed:100/255.f green:180/255.f blue:120/255.f alpha:1.0],
                       [UIColor colorWithRed:100/255.f green:220/255.f blue:150/255.f alpha:1.0],
                       [UIColor colorWithRed:85/255.f green:90/255.f blue:110/255.f alpha:1.0],
                       [UIColor colorWithRed:28/255.f green:28/255.f blue:28/255.f alpha:1.0],
                        nil];
        
//        [self.view addSubview:_bottomVC.view];
#endif
        _eventListViewContoller = [[EventListViewController alloc] initWithFrame:frame];
        [self addChildViewController:_eventListViewContoller];
        [self.view addSubview:_eventListViewContoller.view];
        [self.view setUserInteractionEnabled:YES];
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // fetch EventList
    [DataManager fetch_EventList:^(BOOL isSuccess) {
        if( isSuccess )
        {
#ifdef __TEST_BACK_MENU
            [_tableEventList reloadData];
#endif
            [_eventListViewContoller reloadEventList];
        }
    }];
	// Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void) dealloc
{
    [_arrayEventItems removeAllObjects];
    _arrayEventItems = nil;
#ifdef __TEST_BACK_MENU
    [_tableEventList dealloc];
    [_arrayColor dealloc];
#endif
    [super dealloc];
}

#ifdef __TEST_BACK_MENU
#pragma mark - UITableViewDelegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
    return 0;
}
- (UIView *)tableView:(UITableView *)tableView viewForFooterInSection:(NSInteger)section
{
    return 0;
}
- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
    return 0;
}
- (CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section
{
    return 0;
}


#pragma mark - UITableViewDataSource
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if(indexPath.section ==0) // Cart Items.
    {
        UITableViewCell *cell = [[UITableViewCell alloc] initWithFrame:CGRectMake(0, 0, 320, 60)];
        NSDictionary* dic = [[[DataManager sharedInstance] arrayEventDic] objectAtIndex:indexPath.row];
        
        UILabel *idLabel = [[UILabel alloc] initWithFrame:CGRectMake(10, 10, 220, 16)];
        [idLabel setText:[dic objectForKey:@"name"]];
        idLabel.font = [UIFont fontWithName:@"HelveticaNeue-Bold" size:15];
        [idLabel setBackgroundColor:[UIColor clearColor]];
        [idLabel setTextColor:[UIColor whiteColor]];
        
        UILabel *idTime = [[UILabel alloc] initWithFrame:CGRectMake(10, 30, 220, 16)];
        NSString *strTime = [NSString stringWithFormat:@"%@~%@",[[dic objectForKey:@"start_time"] substringToIndex:10],[[dic objectForKey:@"end_time"] substringToIndex:10]];
        idTime.font = [UIFont fontWithName:@"HelveticaNeue-Bold" size:12];
        [idTime setText:strTime];
        [idTime setBackgroundColor:[UIColor clearColor]];
        [idTime setTextColor:[UIColor whiteColor]];


        [cell.contentView setBackgroundColor:[_arrayColor objectAtIndex:indexPath.row]];
        [cell addSubview:idLabel];
        [cell addSubview:idTime];        
        return cell;
    }
    return nil;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    NSInteger num = 0;
    if(section == 0 ) // Cart Items.
    {
        NSMutableArray* items = [[DataManager sharedInstance] arrayEventDic];
        if(items)
        {
            num = [items count];
        }
        else
        {
            num = 0;
        }
    }
    return num;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    CGFloat height =0;
    if(indexPath.section ==0)
    {
        height = 60;
    }
    return height;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

#endif


- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *t = [touches anyObject];
//    touchPos = [t locationInView:self.v iew];
//    EventItemViewController* cPage = [_arrayEventItems objectAtIndex:currentPage];
//    viewRect = cPage.view.frame;
//    previousTime = [t timestamp];
}


- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *touch = [touches anyObject];
    CGPoint location = [touch locationInView:self.view];
    CGPoint prevLocation = [touch previousLocationInView:self.view];
    
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *touch = [touches anyObject];
    CGPoint location = [touch locationInView:self.view];
    CGPoint prevLocation = [touch previousLocationInView:self.view];
    
}

- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event
{
    
}
@end
