//
//  SignInView.m
//  stylepop
//
//  Created by 경영 임 on 13. 1. 22..
//  Copyright (c) 2013년 Pinatalabs. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import "SignInView.h"
#import "SVHTTPRequest.h"
#import "EventListViewController.h"

@implementation SignInView

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        
        self.layer.borderWidth = 1.0f;
        [self.layer setBorderColor:[UIColor blackColor].CGColor];
        self.layer.cornerRadius = 10.0f;
        [self setBackgroundColor:[UIColor colorWithRed:0.9 green:0.9 blue:0.9 alpha:1.0]];
        UILabel* labelTitleforLV = [[UILabel alloc] initWithFrame:CGRectMake(50, 5, 180, 25)];
        [labelTitleforLV setText:@"로그인"];
        [labelTitleforLV setBackgroundColor:[UIColor clearColor]];
        [labelTitleforLV setTextAlignment:NSTextAlignmentCenter];
        [self addSubview:labelTitleforLV];
        
        UIButton* buttonBack = [[UIButton alloc] initWithFrame:CGRectMake(5, 5, 37,25)];
        [buttonBack setImage:[UIImage imageNamed:@"btn_popup_back_n"] forState:UIControlStateNormal];
        [buttonBack setImage:[UIImage imageNamed:@"btn_popup_back_h"] forState:UIControlStateHighlighted];
        [buttonBack addTarget:self.superview action:@selector(onDimissSignInPopup:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:buttonBack];
        
        UILabel *labelEmail = [[UILabel alloc] initWithFrame:CGRectMake(25, 57, 50, 20)];
        [labelEmail setText:@"이메일"];
        [labelEmail setBackgroundColor:[UIColor clearColor]];
        labelEmail.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [self addSubview:labelEmail];
        
        UILabel *labelPassWord = [[UILabel alloc] initWithFrame:CGRectMake(25, 92, 80, 20)];
        [labelPassWord setText:@"비밀번호"];
        [labelPassWord setBackgroundColor:[UIColor clearColor]];
        labelPassWord.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [self addSubview:labelPassWord];
        
        UIButton* btnLogin = [[UIButton alloc] initWithFrame:CGRectMake(220, 7, 50, 30)];
        [btnLogin setTitle:@"로그인" forState:UIControlStateNormal];
        btnLogin.layer.cornerRadius = 5;
        btnLogin.titleLabel.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [btnLogin setBackgroundColor:[UIColor grayColor]];
        [[btnLogin layer] setBorderWidth:1.0f];
        [btnLogin addTarget:self action:@selector(onSubmit:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:btnLogin];
        
        UIView* bgView = [[UIView alloc] initWithFrame:CGRectMake(15,50,250,75)];
        [bgView setBackgroundColor:[UIColor clearColor]];
        bgView.layer.borderWidth = 1.0f;
        bgView.layer.borderColor = [UIColor colorWithRed:0.7 green:0.7 blue:0.7 alpha:1.0].CGColor;
        bgView.layer.cornerRadius = 5.0f;
        [self addSubview:bgView];
        
        _textEmail = [[UITextField alloc] initWithFrame:CGRectMake(90, 57, 160, 20)];
        [_textEmail setText:@"필수"];
        [_textEmail setTextColor:[UIColor grayColor]];
        [_textEmail setBackgroundColor:[UIColor clearColor]];
        [_textEmail setKeyboardType:UIKeyboardTypeEmailAddress];
        _textEmail.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [self addSubview:_textEmail];
        _textEmail.returnKeyType =  UIReturnKeyNext;
        [_textEmail setSpellCheckingType:UITextSpellCheckingTypeNo];
        [_textEmail setDelegate:self];
        
        _textPassWord = [[UITextField alloc] initWithFrame:CGRectMake(90, 92, 160, 20)];
        [_textPassWord setText:@"필수"];
        [_textPassWord setTextColor:[UIColor grayColor]];
        [_textPassWord setBackgroundColor:[UIColor clearColor]];
        [_textPassWord setKeyboardType:UIKeyboardTypeDefault];
        _textPassWord.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [self addSubview:_textPassWord];
        _textPassWord.returnKeyType =  UIReturnKeyGo;
        [_textPassWord setSpellCheckingType:UITextSpellCheckingTypeNo];
        _textPassWord.secureTextEntry = NO;
        [_textPassWord setDelegate:self];
    }
    return self;
}

-(void) dealloc
{
    [_textEmail dealloc];
    [_textPassWord dealloc];
    [super dealloc];
}

- (void)textFieldDidBeginEditing:(UITextField *)textField
{
    if( [textField isEqual:_textPassWord] && !textField.secureTextEntry)
    {
        textField.enabled = NO;
        textField.secureTextEntry = YES;
        textField.enabled = YES;
        [textField becomeFirstResponder];
    }
    if( textField.textColor==[UIColor grayColor] )
    {
        [textField setText:nil];
        [textField setTextColor:[UIColor blackColor]];
    }
}
-(void)textFieldDidEndEditing:(UITextField *)textField
{
    if( [textField.text length]==0 )
    {
        _textPassWord.secureTextEntry = NO;
        [textField setText:@"필수"];
        [textField setTextColor:[UIColor grayColor]];
    }
}
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    if( [textField isEqual:_textEmail] )
    {
        [_textPassWord becomeFirstResponder];
        return YES;
    }
    [textField resignFirstResponder];
    return YES;
}

-(void) onSubmit:(id)sender
{
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:_textEmail.text,@"user[email]",_textPassWord.text,@"user[password]", nil];
    [SignManager send_SignIn:dic endBlock:^(BOOL isSuccess) {}];
}
@end
