//
//  SignUpView.m
//  stylepop
//
//  Created by 경영 임 on 13. 1. 22..
//  Copyright (c) 2013년 Pinatalabs. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import "SignUpView.h"
#import "SVHTTPRequest.h"
#import "AppDelegate.h"

@implementation SignUpView

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.layer.borderWidth = 1.0f;
        [self.layer setBorderColor:[UIColor blackColor].CGColor];
        self.layer.cornerRadius = 10.0f;
        [self setBackgroundColor:[UIColor colorWithRed:0.9 green:0.9 blue:0.9 alpha:1.0]];
        UILabel* labelTitleforLV = [[UILabel alloc] initWithFrame:CGRectMake(50, 5, 180, 25)];
        [labelTitleforLV setText:@"가입하기"];
        [labelTitleforLV setBackgroundColor:[UIColor clearColor]];
        [labelTitleforLV setTextAlignment:NSTextAlignmentCenter];
        [self addSubview:labelTitleforLV];
        
        UIButton* buttonBack = [[UIButton alloc] initWithFrame:CGRectMake(5, 5, 37,25)];
        [buttonBack setImage:[UIImage imageNamed:@"btn_popup_back_n"] forState:UIControlStateNormal];
        [buttonBack setImage:[UIImage imageNamed:@"btn_popup_back_h"] forState:UIControlStateHighlighted];
        [buttonBack addTarget:self.superview action:@selector(onDimissSignUpPopup:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:buttonBack];
        
        UIButton* btnLogin = [[UIButton alloc] initWithFrame:CGRectMake(220, 7, 50, 25)];
        [btnLogin setTitle:@"가입" forState:UIControlStateNormal];
        btnLogin.layer.cornerRadius = 5;
        btnLogin.titleLabel.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [btnLogin setBackgroundColor:[UIColor grayColor]];
        [[btnLogin layer] setBorderWidth:1.0f];
        [btnLogin addTarget:self action:@selector(onSubmit:) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:btnLogin];
        
        UIButton* btnCamera = [[UIButton alloc] initWithFrame:CGRectMake(105, 55, 72, 70)];
        [btnCamera setImage:[UIImage imageNamed:@"btn_popup_camera_n"] forState:UIControlStateNormal];
        [btnCamera setImage:[UIImage imageNamed:@"btn_popup_camera_h"] forState:UIControlStateHighlighted];
        [self addSubview:btnCamera];
        
        _bgView = [[UIView alloc] initWithFrame:CGRectMake(15,150,250,140)];
        [_bgView setBackgroundColor:[UIColor colorWithRed:0.9 green:0.9 blue:0.9 alpha:1.0]];
        _bgView.layer.borderWidth = 1.0f;
        _bgView.layer.borderColor = [UIColor colorWithRed:0.7 green:0.7 blue:0.7 alpha:1.0].CGColor;
        _bgView.layer.cornerRadius = 5.0f;
        [self addSubview:_bgView];
        
        UILabel *labelEmail = [[UILabel alloc] initWithFrame:CGRectMake(11, 07, 50, 20)];
        [labelEmail setText:@"이메일"];
        [labelEmail setBackgroundColor:[UIColor clearColor]];
        labelEmail.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [_bgView addSubview:labelEmail];
        
        UILabel *labelName = [[UILabel alloc] initWithFrame:CGRectMake(11, 42, 50, 20)];
        [labelName setText:@"이 름"];
        [labelName setBackgroundColor:[UIColor clearColor]];
        labelName.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [_bgView addSubview:labelName];
        
        UILabel *labelPassWord = [[UILabel alloc] initWithFrame:CGRectMake(11, 77, 80, 20)];
        [labelPassWord setText:@"비밀번호"];
        [labelPassWord setBackgroundColor:[UIColor clearColor]];
        labelPassWord.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [_bgView addSubview:labelPassWord];
        
        UILabel *labelPassWord1 = [[UILabel alloc] initWithFrame:CGRectMake(11, 112, 80, 20)];
        [labelPassWord1 setText:@"비밀번호 확인"];
        [labelPassWord1 setBackgroundColor:[UIColor clearColor]];
        labelPassWord1.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [_bgView addSubview:labelPassWord1];
       
        _textEmail = [[UITextField alloc] initWithFrame:CGRectMake(95, 7, 160, 20)];
        [_textEmail setText:@"필수"];
        [_textEmail setTextColor:[UIColor grayColor]];
        [_textEmail setBackgroundColor:[UIColor clearColor]];
        [_textEmail setKeyboardType:UIKeyboardTypeEmailAddress];
        _textEmail.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [_bgView addSubview:_textEmail];
        _textEmail.returnKeyType =  UIReturnKeyNext;
        [_textEmail setSpellCheckingType:UITextSpellCheckingTypeNo];
        [_textEmail setDelegate:self];
        
        _textName = [[UITextField alloc] initWithFrame:CGRectMake(95, 42, 160, 20)];
        [_textName setText:@"필수"];
        [_textName setTextColor:[UIColor grayColor]];
        [_textName setBackgroundColor:[UIColor clearColor]];
        [_textName setKeyboardType:UIKeyboardTypeEmailAddress];
        _textName.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [_bgView addSubview:_textName];
        _textName.returnKeyType =  UIReturnKeyNext;
        [_textName setSpellCheckingType:UITextSpellCheckingTypeNo];
        [_textName setDelegate:self];
        
        _textPassWord = [[UITextField alloc] initWithFrame:CGRectMake(95, 77, 160, 20)];
        [_textPassWord setText:@"필수"];
        [_textPassWord setTextColor:[UIColor grayColor]];
        [_textPassWord setBackgroundColor:[UIColor clearColor]];
        [_textPassWord setKeyboardType:UIKeyboardTypeDefault];
        _textPassWord.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [_bgView addSubview:_textPassWord];
        _textPassWord.returnKeyType =  UIReturnKeyNext;
        [_textPassWord setSpellCheckingType:UITextSpellCheckingTypeNo];
        _textPassWord.secureTextEntry = NO;
        [_textPassWord setDelegate:self];
        
        _textPassWord1 = [[UITextField alloc] initWithFrame:CGRectMake(95, 112, 160, 20)];
        [_textPassWord1 setText:@"필수"];
        [_textPassWord1 setTextColor:[UIColor grayColor]];
        [_textPassWord1 setBackgroundColor:[UIColor clearColor]];
        [_textPassWord1 setKeyboardType:UIKeyboardTypeDefault];
        _textPassWord1.font = [UIFont fontWithName:@"HelveticaNeue-Light" size:14];
        [_bgView addSubview:_textPassWord1];
        _textPassWord1.returnKeyType =  UIReturnKeyGo;
        [_textPassWord1 setSpellCheckingType:UITextSpellCheckingTypeNo];
        _textPassWord1.secureTextEntry = NO;
        [_textPassWord1 setDelegate:self];
    }
    return self;
}

-(void) dealloc
{
    [_textName dealloc];
    [_textEmail dealloc];
    [_textPassWord dealloc];
    [super dealloc];
}


- (void)textFieldDidBeginEditing:(UITextField *)textField
{
    if( ([textField isEqual:_textPassWord] || [textField isEqual:_textPassWord1]) && !textField.secureTextEntry)
    {
        textField.enabled = NO;
        textField.secureTextEntry = YES;
        textField.enabled = YES;
        [textField becomeFirstResponder];
    }
    if( textField.textColor==[UIColor grayColor] )
    {
        [textField setText:nil];
        [textField setTextColor:[UIColor blackColor]];
    }
    
    [UIView transitionWithView:_bgView duration:0.3 options:UIViewAnimationOptionCurveEaseIn animations:^{
        CGRect a = _bgView.frame;
        a.origin.y = 40;
        [_bgView setFrame:a];
    } completion:^(BOOL finished) {
    }];
    
    [UIView transitionWithView:self duration:0.3 options:UIViewAnimationOptionCurveEaseIn animations:^{
        CGRect a = self.frame;
        a.size.height = 190;
        [self setFrame:a];
    } completion:^(BOOL finished) {
    }];
}

-(void)textFieldDidEndEditing:(UITextField *)textField
{
    if( [textField.text length]==0 )
    {
        _textPassWord.secureTextEntry = NO;
        [textField setText:@"필수"];
        [textField setTextColor:[UIColor grayColor]];
    }
}
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    if( [textField isEqual:_textEmail] )
    {
        [_textName becomeFirstResponder];
        return YES;
    }
    if( [textField isEqual:_textName] )
    {
        [_textPassWord becomeFirstResponder];
        return YES;
    }
    if( [textField isEqual:_textPassWord] )
    {
        [_textPassWord1 becomeFirstResponder];
        return YES;
    }
    [UIView transitionWithView:_bgView duration:0.3 options:UIViewAnimationOptionCurveEaseIn animations:^{
        CGRect a = _bgView.frame;
        a.origin.y = 150;
        [_bgView setFrame:a];
    } completion:^(BOOL finished) {
    }];
    [UIView transitionWithView:self duration:0.3 options:UIViewAnimationOptionCurveEaseIn animations:^{
        CGRect a = self.frame;
        a.size.height = 340;
        [self setFrame:a];
    } completion:^(BOOL finished) {
    }];
    [textField resignFirstResponder];
    return YES;
}

-(void) onSubmit:(id)sender
{
    NSDictionary* dic = [NSDictionary dictionaryWithObjectsAndKeys:
                         _textEmail.text,@"user[email]",
                         _textName.text,@"user[name]",
                         _textPassWord.text,@"user[password]",
                         _textPassWord1.text,@"user[password_confirmation]",
                         nil];
    [SignManager send_SignUp:dic endBlockwithResult:^(BOOL isSuccess) {}];
}
@end
